//
//  chronoDataBase.m
//  Chronometer
//
//  Created by Jesus Anaya Orozco on 10/7/12.
//  Copyright (c) 2012 Arkilabs. All rights reserved.
//

#import "chronoDataBase.h"
#import <sqlite3.h>

@implementation chronoDataBase

- (BOOL) initDataBase: (sqlite3 **)database
{
	//we get the db path
	NSString *path = [NSString stringWithFormat:@"%@/Documents/time_records.sqlite", NSHomeDirectory()];
    
	//we try to open the database
	if (sqlite3_open([path UTF8String], database) != SQLITE_OK)
    {
		NSLog(@"Error ocurred open the database");
        return NO;
	}
    
    const char *createTableIfNotExist = "CREATE TABLE IF NOT EXISTS times(time TEXT);";
    int error_code = sqlite3_exec(*database, createTableIfNotExist, NULL, NULL, NULL);
	if (error_code != SQLITE_OK)
    {
        NSLog(@"An error occured creating the talbe times | %@",
                                [NSString stringWithCString: (char *)sqlite3_errmsg(*database)
                                encoding: NSUTF8StringEncoding]
              );
        return NO;
    }
    
    return YES;
}

- (NSMutableArray *) getTimesElements
{
    NSMutableArray *timesList = [[NSMutableArray alloc] initWithCapacity:100];
    sqlite3 *db;
    sqlite3_stmt *statement;
    const char *query = "Select time From times;";
    int i = 0;
    int len;
    
    if(![self initDataBase: &db])
    {
        NSLog(@"Error ocurred open the database");
        return NO;
    }
    
    int error_code = sqlite3_prepare_v2(db, query, -1, &statement, NULL);
    if (error_code == SQLITE_OK)
    {
		while(sqlite3_step(statement) == SQLITE_ROW)
        {
			NSString *value = [[NSString stringWithCString:(char *)sqlite3_column_text(statement, 0)
                               encoding:NSUTF8StringEncoding] copy];
            [timesList addObject:value];
        }
	}
    else
    {
        NSLog(@"An error occured creating the talbe times | %@",
                                    [NSString stringWithCString:(char *)sqlite3_errmsg(db)
                                    encoding:NSUTF8StringEncoding]
              );
    }
    
    for(i = 0, len = (int)[timesList count] / 2; i < len; i++)
    {
        [timesList exchangeObjectAtIndex:i withObjectAtIndex:([timesList count] - i - 1)];
    }

    sqlite3_finalize(statement);
	sqlite3_close(db);
    return timesList;
}

- (void) addNewElement:(NSString *) element
{
    sqlite3 *db;
    int error_code = -1;
    
    NSString *query_insert = [NSString stringWithFormat:@"Insert into times Values('%@');", element];
	
    if(![self initDataBase: &db])
    {
        NSLog(@"Error ocurred open the database");
    }
    
    error_code = sqlite3_exec(db, [query_insert UTF8String], NULL, NULL, NULL);
    
    if(error_code != SQLITE_OK)
    {
        NSLog(@"An error occured adding data in talbe times | %@",
              [NSString stringWithCString:(char *)sqlite3_errmsg(db)
                                 encoding:NSUTF8StringEncoding]
              );
    }
	sqlite3_close(db);
}

@end
