//
//  chronoViewController.m
//  Chronometer
//
//  Created by Jesus Anaya Orozco on 10/6/12.
//  Copyright (c) 2012 Arkilabs. All rights reserved.
//

#import "chronoViewController.h"

@interface chronoViewController ()

@end

@implementation chronoViewController

@synthesize timeButton;
@synthesize timeText;
@synthesize isTimeStarted;

- (void)viewDidLoad
{
    [self setIsTimeStarted: NO];
    database = [[chronoDataBase alloc] init];
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
}

#pragma mark - Chronometer

- (void)onStopOrContinuePressed
{
	
	if (![self isStarted])
    {
         [stopWatchTimer invalidate];
         stopWatchTimer = nil;
         [self updateTimer];
    }
    else
    {
        startDate = [[NSDate date]retain];
         stopWatchTimer = [NSTimer scheduledTimerWithTimeInterval:1.0/10.0
                                                           target:self
                                                         selector:@selector(updateTimer)
                                                         userInfo:nil
                                                          repeats:YES];
    }
}

- (void)updateTimer
{
    NSDate *currentDate = [NSDate date];
    NSTimeInterval timeInterval = [currentDate timeIntervalSinceDate:startDate];
    NSDate *timerDate = [NSDate dateWithTimeIntervalSince1970:timeInterval];
    NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
    [dateFormatter setDateFormat:@"mm:ss:S"];
    [dateFormatter setTimeZone:[NSTimeZone timeZoneForSecondsFromGMT:0.0]];
    NSString *timeString=[dateFormatter stringFromDate:timerDate];
    self.timeText.text = timeString;
    [dateFormatter release];
}

#pragma mark - View lifecycle

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void) saveTimeInDatabase
{
    [database addNewElement: self.timeText.text];
}

- (IBAction)pushTimeButtom:(id)sender
{
    if(![self isStarted])
    {
        [sender setTitle:@"Stop Time" forState:UIControlStateNormal];
        [self setIsTimeStarted: YES];
        
        // start timer chronometer
        startDate = [[NSDate date]retain];
        stopWatchTimer = [NSTimer scheduledTimerWithTimeInterval:1.0/10.0
                                                          target:self
                                                        selector:@selector(updateTimer)
                                                        userInfo:nil
                                                         repeats:YES];
    }
    else
    {
        [sender setTitle:@"Restart Time" forState:UIControlStateNormal];
        [self setIsTimeStarted: NO];
        
        // stop chronometer
        [stopWatchTimer invalidate];
        stopWatchTimer = nil;
        [self updateTimer];
        [self saveTimeInDatabase];
    }
    //[self onStopOrContinuePressed];
}

- (void) dealloc
{
    [timeButton release];
    [timeText release];
    [startDate release];
    [stopWatchTimer release];
    [database release];
    [super dealloc];
}

@end
